
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>Voyager.AIagent &#8212; PhaserVoyager 0.0.1 documentation</title>
    <link rel="stylesheet" href="../../_static/sphinxdoc.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    <script type="text/javascript" id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script type="text/javascript" src="../../_static/jquery.js"></script>
    <script type="text/javascript" src="../../_static/underscore.js"></script>
    <script type="text/javascript" src="../../_static/doctools.js"></script>
    <script type="text/javascript" src="../../_static/language_data.js"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">PhaserVoyager 0.0.1 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../index.html" accesskey="U">Module code</a> &#187;</li> 
      </ul>
    </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <h1>Source code for Voyager.AIagent</h1><div class="highlight"><pre>
<span></span><span class="ch">#! /usr/bin/env python</span>
<span class="c1"># -*- coding: utf-8 -*-</span>

<span class="c1">#####################################################################</span>
<span class="c1">#  Copyright and authorship belong to:                              #</span>
<span class="c1">#  @author: Massimo Sammito                                         #</span>
<span class="c1">#  @email: mds83@cam.ac.uk / massimo.sammito@gmail.com              #</span>
<span class="c1">#####################################################################</span>
<span class="c1">#####################################################################</span>
<span class="c1">#                              LICENSE                              #</span>
<span class="c1">#                                                                   #</span>
<span class="c1">#                                                                   #</span>
<span class="c1">#####################################################################</span>

<span class="c1"># System imports</span>
<span class="kn">from</span> <span class="nn">__future__</span> <span class="kn">import</span> <span class="n">print_function</span>
<span class="kn">from</span> <span class="nn">__future__</span> <span class="kn">import</span> <span class="n">division</span>
<span class="kn">from</span> <span class="nn">future.standard_library</span> <span class="kn">import</span> <span class="n">install_aliases</span>
<span class="kn">import</span> <span class="nn">sys</span>
<span class="kn">import</span> <span class="nn">os</span>
<span class="kn">import</span> <span class="nn">traceback</span>
<span class="kn">import</span> <span class="nn">time</span>
<span class="kn">import</span> <span class="nn">pickle</span>
<span class="kn">import</span> <span class="nn">copy</span>
<span class="kn">import</span> <span class="nn">phenix.command_line.get_cc_mtz_pdb</span> <span class="k">as</span> <span class="nn">get_cc_mtz_pdb</span>

<span class="n">install_aliases</span><span class="p">()</span>


<span class="n">module_path</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">dirname</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">abspath</span><span class="p">(</span><span class="vm">__file__</span><span class="p">))</span>
<span class="n">sys</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">module_path</span><span class="p">,</span> <span class="s2">&quot;../MDSLibraries/&quot;</span><span class="p">))</span>

<span class="kn">import</span> <span class="nn">multiprocessing</span>
<span class="kn">import</span> <span class="nn">shutil</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>
<span class="kn">import</span> <span class="nn">networkx</span> <span class="k">as</span> <span class="nn">nx</span>
<span class="kn">import</span> <span class="nn">simple_tools</span>
<span class="kn">import</span> <span class="nn">system_utility</span>
<span class="kn">import</span> <span class="nn">voyager_dag</span>

<div class="viewcode-block" id="AiAgentError"><a class="viewcode-back" href="../../Voyager.AIagent.html#Voyager.AIagent.AiAgentError">[docs]</a><span class="k">class</span> <span class="nc">AiAgentError</span><span class="p">(</span><span class="ne">Exception</span><span class="p">):</span>
    <span class="k">def</span> <span class="nf">__init_</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">message</span><span class="p">):</span>
        <span class="nb">super</span><span class="p">(</span><span class="n">AiAgentError</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span><span class="o">.</span><span class="fm">__init__</span><span class="p">(</span><span class="n">message</span><span class="p">)</span></div>

<div class="viewcode-block" id="ListCandidates"><a class="viewcode-back" href="../../Voyager.AIagent.html#Voyager.AIagent.ListCandidates">[docs]</a><span class="k">class</span> <span class="nc">ListCandidates</span><span class="p">(</span><span class="nb">object</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    This is ListCandidates</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">arguments</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        example</span>
<span class="sd">        :param arguments:</span>
<span class="sd">        :type arguments:</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">arguments</span> <span class="o">=</span> <span class="n">arguments</span>
        <span class="c1">#TODO: Model extraction a nice feature would be to perform phmmer as alternative whatever other method has been used but only if phmmer was not the selected</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">actions</span> <span class="o">=</span> <span class="p">{</span>
        <span class="s2">&quot;ModelExtraction&quot;</span><span class="p">:[</span>
                            <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">                            voyager.ModelExtraction.maximum_hhpred_models = 1</span>
<span class="sd">                            &quot;&quot;&quot;</span><span class="p">,</span>
                            <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">                            voyager.ModelExtraction.maximum_hhpred_models = 5</span>
<span class="sd">                            &quot;&quot;&quot;</span>
                           <span class="p">],</span>
        <span class="s2">&quot;DomainFromMultAln&quot;</span><span class="p">:[</span>
                            <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">                            voyager.DomainFromMultAln.minscore = 0.6</span>
<span class="sd">                            voyager.DomainFromMultAln.minimum_domain_size= 40</span>
<span class="sd">                            &quot;&quot;&quot;</span><span class="p">,</span>
                            <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">                            voyager.DomainFromMultAln.minscore = 0.3</span>
<span class="sd">                            voyager.DomainFromMultAln.minimum_domain_size= 20</span>
<span class="sd">                            &quot;&quot;&quot;</span>
                            <span class="p">],</span>
        <span class="s2">&quot;ModellingAndProQ3D&quot;</span><span class="p">:[</span>
                            <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">                            voyager.ModellingAndProQ3D.modeling_method = skip</span>
<span class="sd">                            voyager.ModellingAndProQ3D.error_estimation = skip</span>
<span class="sd">                            &quot;&quot;&quot;</span><span class="p">,</span>
                            <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">                            voyager.ModellingAndProQ3D.modeling_method = rosetta</span>
<span class="sd">                            voyager.ModellingAndProQ3D.error_estimation = proq3d</span>
<span class="sd">                            &quot;&quot;&quot;</span><span class="p">,</span>
                             <span class="p">],</span>
        <span class="s2">&quot;Sculptor&quot;</span><span class="p">:</span>         <span class="p">[</span>
                            <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">                            voyager.Sculptor.ErrorEstimationProQ3D.modeling_method = skip</span>
<span class="sd">                            voyager.Sculptor.ErrorEstimationProQ3D.error_estimation = skip</span>
<span class="sd">                            &quot;&quot;&quot;</span><span class="p">,</span>
                            <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">                            voyager.Sculptor.ErrorEstimationProQ3D.modeling_method = rosetta</span>
<span class="sd">                            voyager.Sculptor.ErrorEstimationProQ3D.error_estimation = proq3d</span>
<span class="sd">                            &quot;&quot;&quot;</span>
                            <span class="p">],</span>
        <span class="s2">&quot;DomainFromKmean&quot;</span>   <span class="p">:[</span>
                            <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">                            voyager.DomainFromKmean.radius_sphere = 8</span>
<span class="sd">                            voyager.DomainFromKmean.max_kmeans = 6</span>
<span class="sd">                            voyager.DomainFromKmean.minimum_histogram_correlation = 0.2</span>
<span class="sd">                            voyager.DomainFromKmean.minimum_domain_size = 40</span>
<span class="sd">                            voyager.DomainFromKmean.superposition_core_percentage = 20</span>
<span class="sd">                            &quot;&quot;&quot;</span><span class="p">,</span>
                            <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">                            voyager.DomainFromKmean.radius_sphere = 8</span>
<span class="sd">                            voyager.DomainFromKmean.max_kmeans = 6</span>
<span class="sd">                            voyager.DomainFromKmean.minimum_histogram_correlation = 0.3</span>
<span class="sd">                            voyager.DomainFromKmean.minimum_domain_size = 20</span>
<span class="sd">                            voyager.DomainFromKmean.superposition_core_percentage = 50</span>
<span class="sd">                            &quot;&quot;&quot;</span>
                            <span class="p">],</span>
        <span class="s2">&quot;DomainFinalMerging&quot;</span> <span class="p">:[</span>
                            <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">                            voyager.DomainFinalMerging.minimum_domain_size = 40</span>
<span class="sd">                            voyager.DomainFinalMerging.merging_method = min</span>
<span class="sd">                            voyager.DomainFinalMerging.maximum_number_of_gap_accepted = 8</span>
<span class="sd">                            &quot;&quot;&quot;</span><span class="p">,</span>
                            <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">                            voyager.DomainFinalMerging.minimum_domain_size = 20</span>
<span class="sd">                            voyager.DomainFinalMerging.merging_method = min</span>
<span class="sd">                            voyager.DomainFinalMerging.maximum_number_of_gap_accepted = 5</span>
<span class="sd">                            &quot;&quot;&quot;</span>
                            <span class="p">],</span>
        <span class="s2">&quot;DREnsembler&quot;</span><span class="p">:</span>      <span class="p">[</span>
                            <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">                            voyager.DREnsembler.stop_generation_ensemble_at_ellg = 500</span>
<span class="sd">                            voyager.DREnsembler.minimum_domain_size = 40</span>
<span class="sd">                            voyager.DREnsembler.use_ensembler_trimming_only_to_improve_superposition_core = True</span>
<span class="sd">                            &quot;&quot;&quot;</span><span class="p">,</span>
                            <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">                            voyager.DREnsembler.stop_generation_ensemble_at_ellg = None</span>
<span class="sd">                            voyager.DREnsembler.minimum_domain_size = 20</span>
<span class="sd">                            voyager.DREnsembler.use_ensembler_trimming_only_to_improve_superposition_core = True</span>
<span class="sd">                            &quot;&quot;&quot;</span><span class="p">,</span>
                            <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">                            voyager.DREnsembler.stop_generation_ensemble_at_ellg = None</span>
<span class="sd">                            voyager.DREnsembler.minimum_domain_size = 20</span>
<span class="sd">                            voyager.DREnsembler.use_ensembler_trimming_only_to_improve_superposition_core = False</span>
<span class="sd">                            &quot;&quot;&quot;</span>
                            <span class="p">]</span>
        <span class="p">}</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">conditions</span> <span class="o">=</span> <span class="p">{</span><span class="s2">&quot;Sculptor&quot;</span><span class="p">:{</span><span class="s2">&quot;ModellingAndProQ3D&quot;</span><span class="p">:[</span><span class="mi">0</span><span class="p">,</span><span class="mi">0</span><span class="p">]},</span> <span class="s2">&quot;ModelExtraction&quot;</span><span class="p">:{</span><span class="s2">&quot;voyager&quot;</span><span class="p">:</span><span class="bp">self</span><span class="o">.</span><span class="n">check_conditio_hhpred</span><span class="p">}}</span>

<div class="viewcode-block" id="ListCandidates.check_conditio_hhpred"><a class="viewcode-back" href="../../Voyager.AIagent.html#Voyager.AIagent.ListCandidates.check_conditio_hhpred">[docs]</a>    <span class="k">def</span> <span class="nf">check_conditio_hhpred</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">for</span> <span class="n">r</span><span class="p">,</span> <span class="n">assembly</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">arguments</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">biological_unit</span><span class="p">):</span>
            <span class="k">if</span> <span class="n">assembly</span><span class="o">.</span><span class="n">name_assembly</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span> <span class="k">continue</span>
            <span class="k">for</span> <span class="n">q</span><span class="p">,</span> <span class="n">modelinput</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">assembly</span><span class="o">.</span><span class="n">sequence_or_pdb</span><span class="p">):</span>
                <span class="n">alisource</span> <span class="o">=</span> <span class="n">modelinput</span><span class="o">.</span><span class="n">alignment_source</span>
                <span class="k">if</span> <span class="n">alisource</span> <span class="o">==</span> <span class="s2">&quot;hhpred&quot;</span><span class="p">:</span>
                    <span class="k">return</span> <span class="kc">True</span>
        <span class="k">return</span> <span class="kc">False</span></div>

<div class="viewcode-block" id="ListCandidates.get_actions"><a class="viewcode-back" href="../../Voyager.AIagent.html#Voyager.AIagent.ListCandidates.get_actions">[docs]</a>    <span class="k">def</span> <span class="nf">get_actions</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">actions</span></div>

<div class="viewcode-block" id="ListCandidates.get_param_action"><a class="viewcode-back" href="../../Voyager.AIagent.html#Voyager.AIagent.ListCandidates.get_param_action">[docs]</a>    <span class="k">def</span> <span class="nf">get_param_action</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">action_name</span><span class="p">,</span> <span class="n">index</span><span class="p">,</span> <span class="n">state</span><span class="p">):</span>
        <span class="k">if</span> <span class="n">action_name</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">conditions</span><span class="p">:</span>
            <span class="n">found</span> <span class="o">=</span> <span class="kc">True</span>
            <span class="k">for</span> <span class="n">key</span><span class="p">,</span><span class="n">condi</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">conditions</span><span class="p">[</span><span class="n">action_name</span><span class="p">]</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
                <span class="k">if</span> <span class="n">key</span> <span class="o">==</span> <span class="s2">&quot;voyager&quot;</span><span class="p">:</span>
                    <span class="n">found</span> <span class="o">=</span> <span class="n">condi</span><span class="p">()</span>
                <span class="k">elif</span> <span class="n">index</span> <span class="o">==</span> <span class="n">condi</span><span class="p">[</span><span class="mi">0</span><span class="p">]:</span>
                    <span class="n">f</span> <span class="o">=</span> <span class="kc">False</span>
                    <span class="k">for</span> <span class="n">node</span><span class="p">,</span><span class="n">param</span> <span class="ow">in</span> <span class="n">state</span><span class="o">.</span><span class="n">actions_params</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
                        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">get_actions</span><span class="p">()[</span><span class="n">key</span><span class="p">][</span><span class="n">condi</span><span class="p">[</span><span class="mi">1</span><span class="p">]]</span><span class="o">.</span><span class="n">strip</span><span class="p">()</span> <span class="o">==</span> <span class="n">param</span><span class="o">.</span><span class="n">strip</span><span class="p">():</span>
                            <span class="n">f</span> <span class="o">=</span> <span class="kc">True</span>
                            <span class="k">break</span>
                    <span class="k">if</span> <span class="ow">not</span> <span class="n">f</span><span class="p">:</span>
                        <span class="n">found</span> <span class="o">=</span> <span class="kc">False</span>
                        <span class="k">break</span>
            <span class="k">if</span> <span class="n">found</span><span class="p">:</span>
                <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">get_actions</span><span class="p">()[</span><span class="n">action_name</span><span class="p">][</span><span class="n">index</span><span class="p">]</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="k">return</span> <span class="kc">None</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">get_actions</span><span class="p">()[</span><span class="n">action_name</span><span class="p">][</span><span class="n">index</span><span class="p">]</span></div>

<div class="viewcode-block" id="ListCandidates.list_params"><a class="viewcode-back" href="../../Voyager.AIagent.html#Voyager.AIagent.ListCandidates.list_params">[docs]</a>    <span class="k">def</span> <span class="nf">list_params</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">action_name</span><span class="p">,</span> <span class="n">state</span><span class="p">):</span>
        <span class="n">z</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">for</span> <span class="n">index</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">get_actions</span><span class="p">()[</span><span class="n">action_name</span><span class="p">])):</span>
            <span class="n">q</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">get_param_action</span><span class="p">(</span><span class="n">action_name</span><span class="p">,</span> <span class="n">index</span><span class="p">,</span> <span class="n">state</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">q</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span> <span class="n">z</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">q</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">z</span></div></div>


<div class="viewcode-block" id="AiAgent"><a class="viewcode-back" href="../../Voyager.AIagent.html#Voyager.AIagent.AiAgent">[docs]</a><span class="k">class</span> <span class="nc">AiAgent</span><span class="p">(</span><span class="nb">object</span><span class="p">):</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">strategy</span><span class="p">,</span> <span class="n">arguments</span><span class="p">):</span>
       <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span> <span class="o">=</span> <span class="n">strategy</span>
       <span class="bp">self</span><span class="o">.</span><span class="n">states</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">states</span>
       <span class="bp">self</span><span class="o">.</span><span class="n">arguments</span> <span class="o">=</span> <span class="n">arguments</span>
       <span class="bp">self</span><span class="o">.</span><span class="n">analysed_nodes_per_state</span> <span class="o">=</span> <span class="p">{}</span>
       <span class="bp">self</span><span class="o">.</span><span class="n">current_best_dag_node</span> <span class="o">=</span> <span class="p">{}</span>
       <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">arguments</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">ai_agent</span><span class="o">.</span><span class="n">use_ai_agent</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">listc</span> <span class="o">=</span> <span class="n">ListCandidates</span><span class="p">(</span><span class="n">arguments</span><span class="p">)</span>
       <span class="k">else</span><span class="p">:</span>
           <span class="bp">self</span><span class="o">.</span><span class="n">listc</span> <span class="o">=</span> <span class="kc">None</span>

<div class="viewcode-block" id="AiAgent.get_next"><a class="viewcode-back" href="../../Voyager.AIagent.html#Voyager.AIagent.AiAgent.get_next">[docs]</a>    <span class="k">def</span> <span class="nf">get_next</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">schedule</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Now: The current implementation will iter over all the parameterisation possibilities and will branch each one of them in a different</span>
<span class="sd">             new state_id.</span>
<span class="sd">        Future: The AI should take the decision for the current parameterisation only based on the current running time status of dags, data and models</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">listc</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span> <span class="k">return</span> <span class="kc">None</span>

        <span class="n">i</span><span class="p">,</span> <span class="n">node</span><span class="p">,</span> <span class="n">prevnode</span><span class="p">,</span> <span class="n">state_id</span><span class="p">,</span> <span class="n">priority</span> <span class="o">=</span> <span class="n">schedule</span><span class="p">[</span><span class="mi">1</span><span class="p">:]</span>
        <span class="n">action</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">G</span><span class="o">.</span><span class="n">nodes</span><span class="p">[</span><span class="n">node</span><span class="p">][</span><span class="s2">&quot;action&quot;</span><span class="p">]</span><span class="o">.</span><span class="n">get_name</span><span class="p">()</span>

        <span class="c1">#The action does not have multiple parameterisation and it is going to use the defaults</span>
        <span class="k">if</span> <span class="n">action</span> <span class="ow">not</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">listc</span><span class="o">.</span><span class="n">get_actions</span><span class="p">():</span> <span class="k">return</span> <span class="kc">None</span>

        <span class="c1">#The node has been already configured for the current branch and must be just returned.</span>
        <span class="c1">#This is the case of calling Sculptor or DomainFromMultipleAln multiple times in cycle</span>
        <span class="c1">#within the same branch</span>
        <span class="k">if</span> <span class="n">node</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">states</span><span class="p">[</span><span class="n">state_id</span><span class="p">]</span><span class="o">.</span><span class="n">actions_params</span><span class="p">:</span>
            <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">states</span><span class="p">[</span><span class="n">state_id</span><span class="p">]</span><span class="o">.</span><span class="n">actions_params</span><span class="p">[</span><span class="n">node</span><span class="p">]</span>

        <span class="n">returnparam</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="n">allscheds</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="n">schedstats</span> <span class="o">=</span> <span class="p">[</span><span class="n">schedule</span><span class="p">]</span>
        <span class="k">for</span> <span class="n">nnn</span><span class="p">,</span><span class="n">sched</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">states</span><span class="p">[</span><span class="n">state_id</span><span class="p">]</span><span class="o">.</span><span class="n">running_actions</span><span class="o">.</span><span class="n">items</span><span class="p">():</span> <span class="n">schedstats</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">sched</span><span class="p">)</span>

        <span class="k">while</span> <span class="mi">1</span><span class="p">:</span>
            <span class="k">try</span><span class="p">:</span>
                <span class="n">s</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">scheduler_queue_receive</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="kc">False</span><span class="p">)</span>
                <span class="k">if</span> <span class="n">s</span><span class="p">[</span><span class="o">-</span><span class="mi">2</span><span class="p">]</span> <span class="o">==</span> <span class="n">state_id</span><span class="p">:</span> <span class="n">schedstats</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">s</span><span class="p">)</span>
                <span class="n">allscheds</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">s</span><span class="p">)</span>
            <span class="k">except</span><span class="p">:</span>
                <span class="k">for</span> <span class="n">sched</span> <span class="ow">in</span> <span class="n">allscheds</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">scheduler_queue_receive</span><span class="o">.</span><span class="n">put</span><span class="p">(</span><span class="n">sched</span><span class="p">)</span>
                <span class="k">break</span>

        <span class="k">for</span> <span class="n">z</span><span class="p">,</span><span class="n">par</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">listc</span><span class="o">.</span><span class="n">list_params</span><span class="p">(</span><span class="n">action</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">states</span><span class="p">[</span><span class="n">state_id</span><span class="p">])):</span>
            <span class="k">if</span> <span class="n">z</span> <span class="o">==</span> <span class="mi">0</span><span class="p">:</span>
                <span class="n">returnparam</span> <span class="o">=</span> <span class="n">par</span><span class="o">.</span><span class="n">strip</span><span class="p">()</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">states</span><span class="p">[</span><span class="n">state_id</span><span class="p">]</span><span class="o">.</span><span class="n">actions_params</span><span class="p">[</span><span class="n">node</span><span class="p">]</span> <span class="o">=</span> <span class="n">returnparam</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">ttt</span> <span class="o">=</span> <span class="n">copy</span><span class="o">.</span><span class="n">deepcopy</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">states</span><span class="p">[</span><span class="n">state_id</span><span class="p">])</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">states</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">ttt</span><span class="p">)</span>
                <span class="n">new_state_id</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">states</span><span class="p">)</span> <span class="o">-</span> <span class="mi">1</span>
                <span class="c1"># newsched = list(copy.deepcopy(schedule))</span>
                <span class="c1"># newsched[-2] = new_state_id  # increasing the new state</span>
                <span class="c1"># newsched[-1] += 1  # decreasing the priority</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">states</span><span class="p">[</span><span class="n">new_state_id</span><span class="p">]</span><span class="o">.</span><span class="n">actions_params</span><span class="p">[</span><span class="n">node</span><span class="p">]</span> <span class="o">=</span> <span class="n">par</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">states</span><span class="p">[</span><span class="n">new_state_id</span><span class="p">]</span><span class="o">.</span><span class="n">state_name</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="n">action</span><span class="p">)</span><span class="o">+</span><span class="s2">&quot;--&quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">z</span><span class="p">)</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">states</span><span class="p">[</span><span class="n">new_state_id</span><span class="p">]</span><span class="o">.</span><span class="n">branched_from</span> <span class="o">=</span> <span class="n">state_id</span>

                <span class="c1">#self.strategy.scheduler_queue_receive.put(tuple(newsched))</span>
                <span class="k">for</span> <span class="n">sched</span> <span class="ow">in</span> <span class="n">schedstats</span><span class="p">:</span>
                    <span class="n">r</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="n">copy</span><span class="o">.</span><span class="n">deepcopy</span><span class="p">((</span><span class="n">sched</span><span class="p">)))</span>
                    <span class="n">r</span><span class="p">[</span><span class="o">-</span><span class="mi">2</span><span class="p">]</span> <span class="o">=</span> <span class="n">new_state_id</span>
                    <span class="n">r</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> <span class="o">+=</span> <span class="mi">1</span>
                    <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Adding to the queue a new parameterisation&quot;</span><span class="p">,</span> <span class="n">r</span><span class="p">)</span>
                    <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">scheduler_queue_receive</span><span class="o">.</span><span class="n">put</span><span class="p">(</span><span class="nb">tuple</span><span class="p">(</span><span class="n">r</span><span class="p">))</span>

        <span class="k">return</span> <span class="n">returnparam</span></div>

<div class="viewcode-block" id="AiAgent.branch_out_from_here"><a class="viewcode-back" href="../../Voyager.AIagent.html#Voyager.AIagent.AiAgent.branch_out_from_here">[docs]</a>    <span class="k">def</span> <span class="nf">branch_out_from_here</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">schedule</span><span class="p">):</span>
        <span class="k">if</span> <span class="n">schedule</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="ow">in</span> <span class="p">[</span><span class="s2">&quot;RESULT_ACTION&quot;</span><span class="p">,</span> <span class="s2">&quot;RESULT_ACTION_ONLY_AFTER&quot;</span><span class="p">]:</span>
            <span class="n">state_id</span> <span class="o">=</span> <span class="n">schedule</span><span class="p">[</span><span class="o">-</span><span class="mi">2</span><span class="p">]</span>
            <span class="n">priority</span> <span class="o">=</span> <span class="n">schedule</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span>
            <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">schedule</span><span class="p">[</span><span class="mi">3</span><span class="p">],</span> <span class="nb">list</span><span class="p">):</span>
                <span class="n">input_node</span> <span class="o">=</span> <span class="n">schedule</span><span class="p">[</span><span class="mi">3</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span>
                <span class="n">avoid_branches</span> <span class="o">=</span> <span class="n">schedule</span><span class="p">[</span><span class="mi">3</span><span class="p">][</span><span class="mi">1</span><span class="p">:]</span>
                <span class="n">schedule</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="n">schedule</span><span class="p">)</span>
                <span class="n">schedule</span><span class="p">[</span><span class="mi">3</span><span class="p">]</span> <span class="o">=</span> <span class="n">input_node</span>
                <span class="n">schedule</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">schedule</span><span class="p">)</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">input_node</span> <span class="o">=</span> <span class="n">schedule</span><span class="p">[</span><span class="mi">3</span><span class="p">]</span>
                <span class="n">avoid_branches</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">return</span> <span class="n">schedule</span>

        <span class="n">branch_input</span> <span class="o">=</span> <span class="s2">&quot;None&quot;</span>
        <span class="k">if</span> <span class="n">schedule</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">==</span> <span class="s2">&quot;RESULT_ACTION&quot;</span><span class="p">:</span>
            <span class="n">branch_input</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">states</span><span class="p">[</span><span class="n">state_id</span><span class="p">]</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">schedule</span><span class="p">[</span><span class="mi">1</span><span class="p">])[</span><span class="s2">&quot;label&quot;</span><span class="p">]</span>
        <span class="k">elif</span> <span class="n">schedule</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">==</span> <span class="s2">&quot;RESULT_ACTION_ONLY_AFTER&quot;</span><span class="p">:</span>
            <span class="n">branch_input</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">states</span><span class="p">[</span><span class="n">state_id</span><span class="p">]</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">input_node</span><span class="p">)[</span><span class="s2">&quot;label&quot;</span><span class="p">]</span>

        <span class="n">allscheds</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="n">schedstats</span> <span class="o">=</span> <span class="p">[</span><span class="n">schedule</span><span class="p">]</span>
        <span class="k">for</span> <span class="n">nnn</span><span class="p">,</span><span class="n">sched</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">states</span><span class="p">[</span><span class="n">state_id</span><span class="p">]</span><span class="o">.</span><span class="n">running_actions</span><span class="o">.</span><span class="n">items</span><span class="p">():</span> <span class="n">schedstats</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">sched</span><span class="p">)</span>

        <span class="k">while</span> <span class="mi">1</span><span class="p">:</span>
            <span class="k">try</span><span class="p">:</span>
                <span class="n">s</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">scheduler_queue_receive</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="kc">False</span><span class="p">)</span>
                <span class="k">if</span> <span class="n">s</span><span class="p">[</span><span class="o">-</span><span class="mi">2</span><span class="p">]</span> <span class="o">==</span> <span class="n">state_id</span><span class="p">:</span> <span class="n">schedstats</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">s</span><span class="p">)</span>
                <span class="n">allscheds</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">s</span><span class="p">)</span>
            <span class="k">except</span><span class="p">:</span>
                <span class="k">for</span> <span class="n">sched</span> <span class="ow">in</span> <span class="n">allscheds</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">scheduler_queue_receive</span><span class="o">.</span><span class="n">put</span><span class="p">(</span><span class="n">sched</span><span class="p">)</span>
                <span class="k">break</span>

        <span class="n">ttt</span> <span class="o">=</span> <span class="n">copy</span><span class="o">.</span><span class="n">deepcopy</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">states</span><span class="p">[</span><span class="n">state_id</span><span class="p">])</span>
        <span class="n">ttt</span><span class="o">.</span><span class="n">state_name</span> <span class="o">=</span> <span class="n">branch_input</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">states</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">ttt</span><span class="p">)</span>
        <span class="n">new_state_id</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">states</span><span class="p">)</span> <span class="o">-</span> <span class="mi">1</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">states</span><span class="p">[</span><span class="n">new_state_id</span><span class="p">]</span><span class="o">.</span><span class="n">branched_from</span> <span class="o">=</span> <span class="n">state_id</span>
        <span class="k">for</span> <span class="n">branr</span> <span class="ow">in</span> <span class="n">avoid_branches</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">states</span><span class="p">[</span><span class="n">new_state_id</span><span class="p">]</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">remove_branch</span><span class="p">(</span><span class="n">branr</span><span class="p">,</span> <span class="n">remove_branch_root</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>

        <span class="c1">#self.strategy.scheduler_queue_receive.put(tuple(newsched))</span>
        <span class="k">for</span> <span class="n">sched</span> <span class="ow">in</span> <span class="n">schedstats</span><span class="p">:</span>
            <span class="n">r</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="n">copy</span><span class="o">.</span><span class="n">deepcopy</span><span class="p">((</span><span class="n">sched</span><span class="p">)))</span>
            <span class="n">r</span><span class="p">[</span><span class="o">-</span><span class="mi">2</span><span class="p">]</span> <span class="o">=</span> <span class="n">new_state_id</span>
            <span class="n">r</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> <span class="o">+=</span> <span class="mi">1</span>
            <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Adding to the queue a new branch with action&quot;</span><span class="p">,</span><span class="n">r</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">scheduler_queue_receive</span><span class="o">.</span><span class="n">put</span><span class="p">(</span><span class="nb">tuple</span><span class="p">(</span><span class="n">r</span><span class="p">))</span>

        <span class="n">schedule</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="n">schedule</span><span class="p">)</span>
        <span class="n">schedule</span><span class="p">[</span><span class="o">-</span><span class="mi">2</span><span class="p">]</span> <span class="o">=</span> <span class="n">new_state_id</span>
        <span class="n">schedule</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> <span class="o">+=</span> <span class="mi">1</span>
        <span class="n">schedule</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">schedule</span><span class="p">)</span>

        <span class="k">return</span> <span class="n">schedule</span></div>

<div class="viewcode-block" id="AiAgent.analyse"><a class="viewcode-back" href="../../Voyager.AIagent.html#Voyager.AIagent.AiAgent.analyse">[docs]</a>    <span class="k">def</span> <span class="nf">analyse</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">check_ending</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">stateid</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Now: It does nothing</span>
<span class="sd">        Future: The AI should analyse all the open branches ([x.voyager_dag for x in self.states]) and decide</span>
<span class="sd">                if the priority for that branch should be changed (increased or decreased) and if a branch should die or not</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1">#NOTE: Analyse has to look at current dags branched and decide things like:</span>
        <span class="c1">#1) Open a new branch?</span>
        <span class="c1">#2) Close a branch because is signficantlly worst</span>
        <span class="c1">#3) Change priority to branches</span>
        <span class="c1">#4) Kill a branch if it is turns out to produce exactly the same output as another branch</span>
        <span class="c1">#5) Inspewcting a dag branch and decide if we want to continue with streamed output even if the action has not finished</span>
        <span class="c1">#   for example if a rotation is available and it is good do we want to carry out to search traslation before the rotation function ends?</span>

        <span class="c1">#NODE: Explore all the dags in all the states in search of mr_solution, follow each solution until the leaf</span>
        <span class="c1">#print(&quot;AIAGENT================&quot;)</span>
        <span class="n">sys</span><span class="o">.</span><span class="n">stdout</span><span class="o">.</span><span class="n">flush</span><span class="p">()</span>
        <span class="k">for</span> <span class="n">i</span><span class="p">,</span><span class="n">state</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">states</span><span class="p">):</span>
            <span class="n">nodes_found</span> <span class="o">=</span> <span class="p">[]</span>
            <span class="n">dag</span> <span class="o">=</span> <span class="n">state</span><span class="o">.</span><span class="n">voyager_dag</span>
            <span class="n">q</span> <span class="o">=</span> <span class="p">[</span><span class="n">nd</span> <span class="k">for</span> <span class="n">nd</span> <span class="ow">in</span> <span class="n">dag</span><span class="o">.</span><span class="n">iter_over_nodes</span><span class="p">()</span> <span class="k">if</span> <span class="n">dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">nd</span><span class="p">)[</span><span class="s2">&quot;type&quot;</span><span class="p">]</span><span class="o">==</span><span class="s2">&quot;modelcontainer&quot;</span> <span class="ow">and</span> <span class="s2">&quot;solution&quot;</span> <span class="ow">in</span> <span class="n">dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">nd</span><span class="p">)</span> <span class="ow">and</span> <span class="n">dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">nd</span><span class="p">)[</span><span class="s2">&quot;solution&quot;</span><span class="p">]</span> <span class="ow">and</span> <span class="p">(</span><span class="n">i</span> <span class="ow">not</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">analysed_nodes_per_state</span> <span class="ow">or</span> <span class="n">nd</span> <span class="ow">not</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">analysed_nodes_per_state</span><span class="p">[</span><span class="n">i</span><span class="p">])]</span>
            <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">q</span><span class="p">)</span> <span class="o">==</span> <span class="mi">0</span><span class="p">:</span> <span class="k">continue</span>
            <span class="c1">#NOTE: Sort them by LLG and write down in the disk the current best.pdb and current best.mtz</span>
            <span class="n">q</span> <span class="o">=</span> <span class="nb">sorted</span><span class="p">(</span><span class="n">q</span><span class="p">,</span> <span class="n">key</span><span class="o">=</span><span class="k">lambda</span> <span class="n">x</span><span class="p">:</span> <span class="n">dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">x</span><span class="p">)[</span><span class="s2">&quot;data&quot;</span><span class="p">][</span><span class="s2">&quot;llg&quot;</span><span class="p">],</span> <span class="n">reverse</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
            <span class="n">best</span> <span class="o">=</span> <span class="n">q</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
            <span class="k">if</span> <span class="s2">&quot;llg&quot;</span> <span class="ow">not</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">current_best_dag_node</span> <span class="ow">or</span> <span class="n">dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">best</span><span class="p">)[</span><span class="s2">&quot;data&quot;</span><span class="p">][</span><span class="s2">&quot;llg&quot;</span><span class="p">]</span> <span class="o">&gt;</span> <span class="bp">self</span><span class="o">.</span><span class="n">current_best_dag_node</span><span class="p">[</span><span class="s2">&quot;llg&quot;</span><span class="p">]:</span>
                <span class="n">solutionpdbmtz</span> <span class="o">=</span> <span class="n">voyager_dag</span><span class="o">.</span><span class="n">VoyagerDag</span><span class="o">.</span><span class="n">extract_from_db</span><span class="p">(</span><span class="n">dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">([</span><span class="n">xo</span> <span class="k">for</span> <span class="n">xo</span> <span class="ow">in</span> <span class="n">dag</span><span class="o">.</span><span class="n">successors</span><span class="p">(</span><span class="n">best</span><span class="p">)][</span><span class="mi">0</span><span class="p">])[</span><span class="s2">&quot;model_identifier&quot;</span><span class="p">],</span> <span class="n">where</span><span class="o">=</span><span class="s2">&quot;.&quot;</span><span class="p">)</span>
                <span class="n">solutionpdb</span> <span class="o">=</span> <span class="p">[</span><span class="n">x</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">solutionpdbmtz</span> <span class="k">if</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">basename</span><span class="p">(</span><span class="n">x</span><span class="p">)</span><span class="o">.</span><span class="n">endswith</span><span class="p">(</span><span class="s2">&quot;.pdb&quot;</span><span class="p">)][</span><span class="mi">0</span><span class="p">]</span>
                <span class="n">solutionmtz</span> <span class="o">=</span> <span class="p">[</span><span class="n">x</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">solutionpdbmtz</span> <span class="k">if</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">basename</span><span class="p">(</span><span class="n">x</span><span class="p">)</span><span class="o">.</span><span class="n">endswith</span><span class="p">(</span><span class="s2">&quot;.mtz&quot;</span><span class="p">)]</span>
                <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">solutionmtz</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">:</span>
                    <span class="n">solutionmtz</span> <span class="o">=</span> <span class="n">solutionmtz</span><span class="o">.</span><span class="n">pop</span><span class="p">(</span><span class="mi">0</span><span class="p">)</span>
                <span class="k">else</span><span class="p">:</span>
                    <span class="n">solutionmtz</span> <span class="o">=</span> <span class="kc">None</span>
                <span class="n">shutil</span><span class="o">.</span><span class="n">copyfile</span><span class="p">(</span><span class="n">solutionpdb</span><span class="p">,</span> <span class="s2">&quot;best.pdb&quot;</span><span class="p">)</span>
                <span class="n">os</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="n">solutionpdb</span><span class="p">)</span>
                <span class="k">if</span> <span class="n">solutionmtz</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                    <span class="n">shutil</span><span class="o">.</span><span class="n">copyfile</span><span class="p">(</span><span class="n">solutionmtz</span><span class="p">,</span> <span class="s2">&quot;best.mtz&quot;</span><span class="p">)</span>
                    <span class="n">os</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="n">solutionmtz</span><span class="p">)</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">current_best_dag_node</span><span class="p">[</span><span class="s2">&quot;node&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">best</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">current_best_dag_node</span><span class="p">[</span><span class="s2">&quot;llg&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">best</span><span class="p">)[</span><span class="s2">&quot;data&quot;</span><span class="p">][</span><span class="s2">&quot;llg&quot;</span><span class="p">]</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">current_best_dag_node</span><span class="p">[</span><span class="s2">&quot;zscore&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">best</span><span class="p">)[</span><span class="s2">&quot;data&quot;</span><span class="p">][</span><span class="s2">&quot;zscore&quot;</span><span class="p">]</span>

            <span class="c1">#TODO: In the future ai_agent will notify to the Gui about the new current bests and the GUI will display them in realtime</span>
            <span class="c1"># self.strategy.notify_gui_best_pdb_mtz(best_pdb, best_mtz)</span>

            <span class="k">if</span> <span class="n">check_ending</span> <span class="ow">and</span> <span class="p">(</span><span class="n">stateid</span> <span class="ow">is</span> <span class="kc">None</span> <span class="ow">or</span> <span class="n">stateid</span><span class="o">==</span><span class="n">i</span><span class="p">):</span>
                <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;CHECK-ENDING&quot;</span><span class="p">)</span>
                <span class="n">dirol</span> <span class="o">=</span> <span class="n">simple_tools</span><span class="o">.</span><span class="n">create_directory_timestamp</span><span class="p">(</span><span class="s2">&quot;./evaluate_best_&quot;</span><span class="p">)</span>
                <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Best&quot;</span><span class="p">,</span><span class="n">best</span><span class="p">,</span><span class="n">dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">best</span><span class="p">)[</span><span class="s2">&quot;label&quot;</span><span class="p">],</span><span class="n">dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">best</span><span class="p">)[</span><span class="s2">&quot;data&quot;</span><span class="p">][</span><span class="s2">&quot;llg&quot;</span><span class="p">])</span>
                <span class="c1">#NOTE: For each possible solution explore the following ifs but skipping all the nodes that have already been seen</span>
                <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">arguments</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">ai_agent</span><span class="o">.</span><span class="n">post_mortem</span><span class="o">.</span><span class="n">target_structure</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span> <span class="ow">and</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">exists</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">arguments</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">ai_agent</span><span class="o">.</span><span class="n">post_mortem</span><span class="o">.</span><span class="n">target_structure</span><span class="p">):</span>
                    <span class="n">solutionpdbmtz</span> <span class="o">=</span> <span class="n">voyager_dag</span><span class="o">.</span><span class="n">VoyagerDag</span><span class="o">.</span><span class="n">extract_from_db</span><span class="p">(</span><span class="n">dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">([</span><span class="n">xo</span> <span class="k">for</span> <span class="n">xo</span> <span class="ow">in</span> <span class="n">dag</span><span class="o">.</span><span class="n">successors</span><span class="p">(</span><span class="n">best</span><span class="p">)][</span><span class="mi">0</span><span class="p">])[</span><span class="s2">&quot;model_identifier&quot;</span><span class="p">],</span> <span class="n">where</span><span class="o">=</span><span class="n">dirol</span><span class="p">)</span>
                    <span class="nb">print</span><span class="p">(</span><span class="n">solutionpdbmtz</span><span class="p">)</span>
                    <span class="n">solutionpdb</span> <span class="o">=</span> <span class="p">[</span><span class="n">x</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">solutionpdbmtz</span> <span class="k">if</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">basename</span><span class="p">(</span><span class="n">x</span><span class="p">)</span><span class="o">.</span><span class="n">endswith</span><span class="p">(</span><span class="s2">&quot;.pdb&quot;</span><span class="p">)][</span><span class="mi">0</span><span class="p">]</span>
                    <span class="n">solutionmtz</span> <span class="o">=</span> <span class="p">[</span><span class="n">x</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">solutionpdbmtz</span> <span class="k">if</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">basename</span><span class="p">(</span><span class="n">x</span><span class="p">)</span><span class="o">.</span><span class="n">endswith</span><span class="p">(</span><span class="s2">&quot;.mtz&quot;</span><span class="p">)]</span>
                    <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">solutionmtz</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">:</span>
                        <span class="n">solutionmtz</span> <span class="o">=</span> <span class="n">solutionmtz</span><span class="o">.</span><span class="n">pop</span><span class="p">(</span><span class="mi">0</span><span class="p">)</span>
                    <span class="k">else</span><span class="p">:</span>
                        <span class="n">solutionmtz</span> <span class="o">=</span> <span class="kc">None</span>

                    <span class="nb">print</span><span class="p">(</span><span class="n">solutionmtz</span><span class="p">)</span>
                    <span class="k">if</span> <span class="n">solutionmtz</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                        <span class="n">results</span> <span class="o">=</span> <span class="n">get_cc_mtz_pdb</span><span class="o">.</span><span class="n">get_cc_mtz_pdb</span><span class="p">([</span><span class="bp">self</span><span class="o">.</span><span class="n">arguments</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">ai_agent</span><span class="o">.</span><span class="n">post_mortem</span><span class="o">.</span><span class="n">target_structure</span><span class="p">,</span> <span class="n">solutionmtz</span><span class="p">,</span> <span class="s2">&quot;output_dir=&quot;</span><span class="o">+</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">abspath</span><span class="p">(</span><span class="n">dirol</span><span class="p">)])</span>
                        <span class="n">overallcc</span> <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">results</span><span class="o">.</span><span class="n">found_overall</span><span class="p">)</span>
                        <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;OverallCC&quot;</span><span class="p">,</span><span class="n">overallcc</span><span class="p">,</span><span class="s2">&quot;self.arguments.voyager.ai_agent.post_mortem.stop_if_cc_greater_than&quot;</span><span class="p">,</span><span class="bp">self</span><span class="o">.</span><span class="n">arguments</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">ai_agent</span><span class="o">.</span><span class="n">post_mortem</span><span class="o">.</span><span class="n">stop_if_cc_greater_than</span><span class="p">)</span>
                        <span class="k">if</span> <span class="n">overallcc</span> <span class="o">&gt;=</span> <span class="bp">self</span><span class="o">.</span><span class="n">arguments</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">ai_agent</span><span class="o">.</span><span class="n">post_mortem</span><span class="o">.</span><span class="n">stop_if_cc_greater_than</span><span class="p">:</span>
                            <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Overall CC vs Target structure&quot;</span><span class="p">,</span><span class="bp">self</span><span class="o">.</span><span class="n">arguments</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">ai_agent</span><span class="o">.</span><span class="n">post_mortem</span><span class="o">.</span><span class="n">target_structure</span><span class="p">)</span>
                            <span class="k">if</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">exists</span><span class="p">(</span><span class="n">dirol</span><span class="p">):</span> <span class="n">shutil</span><span class="o">.</span><span class="n">rmtree</span><span class="p">(</span><span class="n">dirol</span><span class="p">)</span>
                            <span class="k">if</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">exists</span><span class="p">(</span><span class="s2">&quot;temp_dir&quot;</span><span class="p">):</span> <span class="n">shutil</span><span class="o">.</span><span class="n">rmtree</span><span class="p">(</span><span class="s2">&quot;temp_dir&quot;</span><span class="p">)</span>
                            <span class="k">return</span> <span class="kc">True</span>

                <span class="k">elif</span> <span class="ow">not</span> <span class="bp">self</span><span class="o">.</span><span class="n">arguments</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">ai_agent</span><span class="o">.</span><span class="n">ending_criteria</span><span class="o">.</span><span class="n">exhaustive</span><span class="p">:</span>
                        <span class="c1">#NOTE: Check if the LLG computed vs the target structure &gt;=  self.arguments.voyager.ai_agent.ending_criteria.minimum_llg</span>
                        <span class="c1">#NOTE: Check if the Zscore computed vs the target structure &gt;= self.arguments.voyager.ai_agent.ending_criteria.minimum_zscore</span>
                        <span class="n">sol</span> <span class="o">=</span> <span class="n">dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">best</span><span class="p">)[</span><span class="s2">&quot;data&quot;</span><span class="p">]</span>
                        <span class="k">if</span> <span class="n">sol</span><span class="p">[</span><span class="s2">&quot;llg&quot;</span><span class="p">]</span> <span class="o">&gt;=</span> <span class="bp">self</span><span class="o">.</span><span class="n">arguments</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">ai_agent</span><span class="o">.</span><span class="n">ending_criteria</span><span class="o">.</span><span class="n">minimum_llg</span> <span class="ow">and</span> <span class="n">sol</span><span class="p">[</span><span class="s2">&quot;zscore&quot;</span><span class="p">]</span> <span class="o">&gt;=</span> <span class="bp">self</span><span class="o">.</span><span class="n">arguments</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">ai_agent</span><span class="o">.</span><span class="n">ending_criteria</span><span class="o">.</span><span class="n">minimum_zscore</span><span class="p">:</span>
                            <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;LLG reached ending criteria:&quot;</span><span class="p">,</span><span class="n">sol</span><span class="p">[</span><span class="s2">&quot;llg&quot;</span><span class="p">])</span>
                            <span class="k">if</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">exists</span><span class="p">(</span><span class="n">dirol</span><span class="p">):</span> <span class="n">shutil</span><span class="o">.</span><span class="n">rmtree</span><span class="p">(</span><span class="n">dirol</span><span class="p">)</span>
                            <span class="k">return</span> <span class="kc">True</span>

                <span class="k">if</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">exists</span><span class="p">(</span><span class="n">dirol</span><span class="p">):</span> <span class="n">shutil</span><span class="o">.</span><span class="n">rmtree</span><span class="p">(</span><span class="n">dirol</span><span class="p">)</span>

        <span class="k">return</span> <span class="kc">False</span></div></div>

</pre></div>

          </div>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">PhaserVoyager 0.0.1 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../index.html" >Module code</a> &#187;</li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2020, Massimo D. Sammito.
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 1.8.5.
    </div>
  </body>
</html>